package pt.uc.dei.wsdbench.sut.service.delegate.impl.pedro;

import java.sql.ResultSet;
import java.sql.SQLException;

import pt.uc.dei.wsdbench.sut.external.LongWrapper;
import pt.uc.dei.wsdbench.sut.external.Pov;
import pt.uc.dei.wsdbench.sut.service.delegate.IChangePaymentMethodServiceDelegate;
import pt.uc.dei.wsdbench.sut.service.input.ChangePaymentMethodInput;
import pt.uc.dei.wsdbench.sut.service.output.ChangePaymentMethodOutput;

public class ChangePaymentMethodServiceDelegate implements IChangePaymentMethodServiceDelegate {

    private String server = "10.3.3.191";
    private int port = 1521;
    private String sid = "orcl";
    private String userName = "wsdbench";
    private String passwd = "samsung";
    Database db = null;

    public ChangePaymentMethodOutput process(final ChangePaymentMethodInput input) throws SQLException {
        ChangePaymentMethodOutput cpmo = new ChangePaymentMethodOutput();
        db = new Database(server, port, sid, userName, passwd);
        String c_b_name = null;
        if (input.getPaymentMethod().equalsIgnoreCase("PO")) {
            try {
                if (db.connectDB()) {
                    Long cid = input.getCustomerId();
                    if (cid != null) {
                        long c_id = cid.longValue();
                        c_b_name = getBusiName(c_id);
                    }
                    db.closeDB();
                } else {
                    db.closeDB();
                    throw new SQLException("Cannot Establish Connection");
                }
                // initiates a web service request to the POV to validate the
                // CREDIT_INFO
                String poId = input.getPoId();
                if ((poId != null) && (c_b_name != null)) {
                    Pov pov = new Pov();
                    LongWrapper wrapper = pov.call(poId, c_b_name);
                    wrapper.getValue().getClass();
                }

                if (db.connectDB()) {
                    String c_payment_method = updateCPM(input);
                    db.closeDB();
                    if (c_payment_method != null) {
                        cpmo.setCurrPaymentMethod(c_payment_method);
                    }
                } else {
                    db.closeDB();
                    throw new SQLException("Cannot Establish Connection");
                }
            } catch (SQLException e) {
                db.closeDB();
                // e.printStackTrace();
                throw e;
            }
        }
        System.gc();
        return cpmo;
    }

    private synchronized String updateCPM(final ChangePaymentMethodInput input)
            throws SQLException {
        String cpm = null;
        String sql = "update customer SET" + " C_PAYMENT_METHOD= '" + input.getPaymentMethod() + "'," + " C_CREDIT_INFO= '" + input.getCreditInfo() + "'," + " C_PO= " + input.getPoId() + " where C_ID = " + input.getCustomerId();
        int rc = db.executeCmd(sql);
        cpm = input.getPaymentMethod();
        return (cpm);
    }

    private synchronized String getBusiName(long c_id) throws SQLException {
        String cbn = null;
        String sql = "select c_business_name from customer where c_id = " + c_id;
        // System.out.println("\n"+sql);
        // try
        // {
        ResultSet rs = db.executeQuery(sql);
        if (rs.next()) {
            cbn = rs.getString(1);
        }
        if (rs != null) {
            rs.close();
        }
        // }
        // catch (SQLException e)
        // {
        // // TODO Auto-generated catch block
        // e.printStackTrace();
        // }
        return (cbn);
    }
}
